Index: boot/Makefile.uboot
===================================================================
--- boot/Makefile.uboot	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/Makefile.uboot	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -40,5 +40,5 @@
 
 $(POST_OUTPUT): $(BIN_OUTPUT)
-	$(MKUIMAGE) -name "$(IMAGE_NAME)" -laddr $(LADDR) -saddr $(SADDR) $< $@
+	$(MKUIMAGE) -name "$(IMAGE_NAME)" -laddr 0x30008000 -saddr 0x30008000 $< $@
 
 clean:
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/Makefile.inc	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -30,14 +30,4 @@
 	BOOT_OUTPUT = image.boot
 	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
-	LADDR = 0x30008000
-	SADDR = 0x30008000
-	POSTBUILD = Makefile.uboot
-endif
-
-ifeq ($(MACHINE), beagleboardxm)
-	BOOT_OUTPUT = image.boot
-	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
-	LADDR = 0x80000000
-	SADDR = 0x80000000
 	POSTBUILD = Makefile.uboot
 endif
@@ -51,24 +41,10 @@
 EXTRA_CFLAGS = -march=armv4
 
-ifeq ($(MACHINE), gta02)
 RD_SRVS_ESSENTIAL += \
 	$(USPACE_PATH)/srv/hid/s3c24xx_ts/s3c24ts \
 	$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24ser
-endif
 
-ifeq ($(MACHINE), gxemul)
 RD_SRVS_NON_ESSENTIAL += \
 	$(USPACE_PATH)/srv/bd/gxe_bd/gxe_bd
-endif
-
-RD_DRVS += \
-	infrastructure/rootamdm37x \
-	bus/usb/ehci \
-	bus/usb/ohci \
-	bus/usb/usbflbk \
-	bus/usb/usbhub \
-	bus/usb/usbhid \
-	bus/usb/usbmast \
-	bus/usb/usbmid
 
 SOURCES = \
Index: boot/arch/arm32/include/arch.h
===================================================================
--- boot/arch/arm32/include/arch.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/include/arch.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -42,6 +42,4 @@
 #ifdef MACHINE_gta02
 #define BOOT_BASE	0x30008000
-#elif defined MACHINE_beagleboardxm
-#define BOOT_BASE	0x80000000
 #else
 #define BOOT_BASE	0x00000000
@@ -50,16 +48,9 @@
 #define BOOT_OFFSET	(BOOT_BASE + 0xa00000)
 
-#ifdef MACHINE_beagleboardxm
-	#define PA_OFFSET 0
+#ifndef __ASM__
+	#define PA2KA(addr)  (((uintptr_t) (addr)) + 0x80000000)
 #else
-	#define PA_OFFSET 0x80000000
+	#define PA2KA(addr)  ((addr) + 0x80000000)
 #endif
-
-#ifndef __ASM__
-	#define PA2KA(addr)  (((uintptr_t) (addr)) + PA_OFFSET)
-#else
-	#define PA2KA(addr)  ((addr) + PA_OFFSET)
-#endif
-
 
 #endif
Index: boot/arch/arm32/include/main.h
===================================================================
--- boot/arch/arm32/include/main.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/include/main.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -40,16 +40,4 @@
 /** Address where characters to be printed are expected. */
 
-
-/** BeagleBoard-xM UART register address
- *
- * This is UART3 of AM/DM37x CPU
- */
-#define BBXM_SCONS_THR          0x49020000
-#define BBXM_SCONS_SSR          0x49020044
-
-/* Check this bit before writing (tx fifo full) */
-#define BBXM_THR_FULL           0x00000001
-
-
 /** GTA02 serial console UART register addresses.
  *
Index: boot/arch/arm32/include/mm.h
===================================================================
--- boot/arch/arm32/include/mm.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/include/mm.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -58,13 +58,9 @@
 	unsigned int bufferable : 1;
 	unsigned int cacheable : 1;
-	unsigned int xn : 1;
+	unsigned int impl_specific : 1;
 	unsigned int domain : 4;
 	unsigned int should_be_zero_1 : 1;
-	unsigned int access_permission_0 : 2;
-	unsigned int tex : 3;
-	unsigned int access_permission_1 : 2;
-	unsigned int non_global : 1;
-	unsigned int should_be_zero_2 : 1;
-	unsigned int non_secure : 1;
+	unsigned int access_permission : 2;
+	unsigned int should_be_zero_2 : 8;
 	unsigned int section_base_addr : 12;
 } __attribute__((packed)) pte_level0_section_t;
Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/src/mm.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -54,15 +54,11 @@
 {
 	pte->descriptor_type = PTE_DESCRIPTOR_SECTION;
-	pte->bufferable = 1;
+	pte->bufferable = 0;
 	pte->cacheable = 0;
-	pte->xn = 0;
+	pte->impl_specific = 0;
 	pte->domain = 0;
 	pte->should_be_zero_1 = 0;
-	pte->access_permission_0 = PTE_AP_USER_NO_KERNEL_RW;
-	pte->tex = 0;
-	pte->access_permission_1 = 0;
-	pte->non_global = 0;
+	pte->access_permission = PTE_AP_USER_NO_KERNEL_RW;
 	pte->should_be_zero_2 = 0;
-	pte->non_secure = 0;
 	pte->section_base_addr = frame;
 }
@@ -71,5 +67,6 @@
 static void init_boot_pt(void)
 {
-	const pfn_t split_page = PTL0_ENTRIES;
+	pfn_t split_page = 0x800;
+	
 	/* Create 1:1 virtual-physical mapping (in lower 2 GB). */
 	pfn_t page;
@@ -81,13 +78,6 @@
 	 * (upper 2 GB), physical addresses start from 0.
 	 */
-	/* BeagleBoard-xM (MD37x) memory starts at 2GB border,
-	 * thus mapping only lower 2GB is not not enough.
-	 * Map entire AS 1:1 instead and hope it works. */
 	for (page = split_page; page < PTL0_ENTRIES; page++)
-#ifndef MACHINE_beagleboardxm
 		init_ptl0_section(&boot_pt[page], page - split_page);
-#else
-		init_ptl0_section(&boot_pt[page], page);
-#endif
 	
 	asm volatile (
@@ -105,29 +95,11 @@
 		/* Behave as a client of domains */
 		"ldr r0, =0x55555555\n"
-		"mcr p15, 0, r0, c3, c0, 0\n"
+		"mcr p15, 0, r0, c3, c0, 0\n" 
 		
-#ifdef PROCESSOR_armv7
-		/* Clean L2 cache */
-		"mov r12, #0x1\n"   //set up to invalidate L2
-		"smc #0\n"  //Call SMI monitor
-		
-		/* Read Auxiliary control register */
-		"mrc p15, 0, r0, c1, c0, 1\n"
-		/* Mask to enable L2 cache */
-		"ldr r1, =0x00000002\n"
-		"orr r0, r0, r1\n"
-		/* Store Auxiliary control register */
-		"mrc p15, 0, r0, c1, c0, 1\n"
-#endif
 		/* Current settings */
 		"mrc p15, 0, r0, c1, c0, 0\n"
 		
-#ifdef PROCESSOR_armv7
-		/* Mask to enable paging, alignment and caching */
-		"ldr r1, =0x00000007\n"
-#else
 		/* Mask to enable paging */
 		"ldr r1, =0x00000001\n"
-#endif
 		"orr r0, r0, r1\n"
 		
Index: boot/arch/arm32/src/putchar.c
===================================================================
--- boot/arch/arm32/src/putchar.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ boot/arch/arm32/src/putchar.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -40,26 +40,4 @@
 #include <putchar.h>
 #include <str.h>
-
-#ifdef MACHINE_beagleboardxm
-
-/** Send a byte to the amdm37x serial console.
- *
- * @param byte		Byte to send.
- */
-static void scons_sendb_bbxm(uint8_t byte)
-{
-	volatile uint32_t *thr =
-	    (volatile uint32_t *)BBXM_SCONS_THR;
-	volatile uint32_t *ssr =
-	    (volatile uint32_t *)BBXM_SCONS_SSR;
-
-	/* Wait until transmitter is empty. */
-	while ((*ssr & BBXM_THR_FULL) == 1) ;
-
-	/* Transmit byte. */
-	*thr = (uint32_t) byte;
-}
-
-#endif
 
 #ifdef MACHINE_gta02
@@ -119,7 +97,4 @@
 static void scons_sendb(uint8_t byte)
 {
-#ifdef MACHINE_beagleboardxm
-	scons_sendb_bbxm(byte);
-#endif
 #ifdef MACHINE_gta02
 	scons_sendb_gta02(byte);
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/Makefile.inc	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -74,8 +74,4 @@
 endif
 
-ifeq ($(MACHINE),beagleboardxm)
-	ARCH_SOURCES += arch/$(KARCH)/src/mach/beagleboardxm/beagleboardxm.c
-endif
-
 ifeq ($(CONFIG_PL050),y)
 	ARCH_SOURCES += genarch/src/drivers/pl050/pl050.c
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/_link.ld.in	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -9,6 +9,4 @@
 #ifdef MACHINE_gta02
 #define KERNEL_LOAD_ADDRESS 0xb0a08000
-#elif defined MACHINE_beagleboardxm
-#define KERNEL_LOAD_ADDRESS 0x80a00000
 #else
 #define KERNEL_LOAD_ADDRESS 0x80a00000
Index: kernel/arch/arm32/include/asm.h
===================================================================
--- kernel/arch/arm32/include/asm.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/asm.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -43,13 +43,7 @@
 #include <trace.h>
 
-/** No such instruction on old ARM to sleep CPU.
- *
- * ARMv7 introduced wait for event and wait for interrupt (wfe/wfi).
- */
+/** No such instruction on ARM to sleep CPU. */
 NO_TRACE static inline void cpu_sleep(void)
 {
-#ifdef PROCESSOR_armv7
-	asm volatile ( "wfe" :: );
-#endif
 }
 
Index: kernel/arch/arm32/include/cpu.h
===================================================================
--- kernel/arch/arm32/include/cpu.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/cpu.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -41,5 +41,5 @@
 
 
-/** Struct representing ARM CPU identification. */
+/** Struct representing ARM CPU identifiaction. */
 typedef struct {
 	/** Implementator (vendor) number. */
Index: kernel/arch/arm32/include/machine_func.h
===================================================================
--- kernel/arch/arm32/include/machine_func.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/machine_func.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -108,6 +108,4 @@
 extern size_t machine_get_irq_count(void);
 
-extern const char * machine_get_platform_name(void);
-
 #endif
 
Index: kernel/arch/arm32/include/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/mm/frame.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/mm/frame.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -48,6 +48,4 @@
 #ifdef MACHINE_gta02
 #define BOOT_PAGE_TABLE_ADDRESS  0x30010000
-#elif defined MACHINE_beagleboardxm
-#define BOOT_PAGE_TABLE_ADDRESS  0x80008000
 #else
 #define BOOT_PAGE_TABLE_ADDRESS  0x00008000
@@ -59,6 +57,4 @@
 #ifdef MACHINE_gta02
 #define PHYSMEM_START_ADDR	0x30008000
-#elif defined MACHINE_beagleboardxm
-#define PHYSMEM_START_ADDR      0x80000000
 #else
 #define PHYSMEM_START_ADDR	0x00000000
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/mm/page.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -37,13 +37,12 @@
 #define KERN_arm32_PAGE_H_
 
-#ifdef MACHINE_beagleboardxm
-#ifndef __ASM__
-#	define KA2PA(x)	((uintptr_t) (x))
-#	define PA2KA(x)	((uintptr_t) (x))
-#else
-#	define KA2PA(x)	(x)
-#	define PA2KA(x)	(x)
-#endif
-#else
+#include <arch/mm/frame.h>
+#include <mm/mm.h>
+#include <arch/exception.h>
+#include <trace.h>
+
+#define PAGE_WIDTH	FRAME_WIDTH
+#define PAGE_SIZE	FRAME_SIZE
+
 #ifndef __ASM__
 #	define KA2PA(x)	(((uintptr_t) (x)) - 0x80000000)
@@ -53,14 +52,272 @@
 #	define PA2KA(x)	((x) + 0x80000000)
 #endif
+
+/* Number of entries in each level. */
+#define PTL0_ENTRIES_ARCH 	(1 << 12)	/* 4096 */
+#define PTL1_ENTRIES_ARCH 	0
+#define PTL2_ENTRIES_ARCH 	0
+/* coarse page tables used (256 * 4 = 1KB per page) */
+#define PTL3_ENTRIES_ARCH 	(1 << 8)	/* 256 */
+
+/* Page table sizes for each level. */
+#define PTL0_SIZE_ARCH 		FOUR_FRAMES
+#define PTL1_SIZE_ARCH 		0
+#define PTL2_SIZE_ARCH 		0
+#define PTL3_SIZE_ARCH 		ONE_FRAME
+
+/* Macros calculating indices into page tables for each level. */
+#define PTL0_INDEX_ARCH(vaddr) 	(((vaddr) >> 20) & 0xfff)
+#define PTL1_INDEX_ARCH(vaddr) 	0
+#define PTL2_INDEX_ARCH(vaddr) 	0
+#define PTL3_INDEX_ARCH(vaddr) 	(((vaddr) >> 12) & 0x0ff)
+
+/* Get PTE address accessors for each level. */
+#define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
+	((pte_t *) ((((pte_t *)(ptl0))[(i)].l0).coarse_table_addr << 10))
+#define GET_PTL2_ADDRESS_ARCH(ptl1, i) \
+	(ptl1)
+#define GET_PTL3_ADDRESS_ARCH(ptl2, i) \
+	(ptl2)
+#define GET_FRAME_ADDRESS_ARCH(ptl3, i) \
+	((uintptr_t) ((((pte_t *)(ptl3))[(i)].l1).frame_base_addr << 12))
+
+/* Set PTE address accessors for each level. */
+#define SET_PTL0_ADDRESS_ARCH(ptl0) \
+	(set_ptl0_addr((pte_t *) (ptl0)))
+#define SET_PTL1_ADDRESS_ARCH(ptl0, i, a) \
+	(((pte_t *) (ptl0))[(i)].l0.coarse_table_addr = (a) >> 10)
+#define SET_PTL2_ADDRESS_ARCH(ptl1, i, a)
+#define SET_PTL3_ADDRESS_ARCH(ptl2, i, a)
+#define SET_FRAME_ADDRESS_ARCH(ptl3, i, a) \
+	(((pte_t *) (ptl3))[(i)].l1.frame_base_addr = (a) >> 12)
+
+/* Get PTE flags accessors for each level. */
+#define GET_PTL1_FLAGS_ARCH(ptl0, i) \
+	get_pt_level0_flags((pte_t *) (ptl0), (size_t) (i))
+#define GET_PTL2_FLAGS_ARCH(ptl1, i) \
+	PAGE_PRESENT
+#define GET_PTL3_FLAGS_ARCH(ptl2, i) \
+	PAGE_PRESENT
+#define GET_FRAME_FLAGS_ARCH(ptl3, i) \
+	get_pt_level1_flags((pte_t *) (ptl3), (size_t) (i))
+
+/* Set PTE flags accessors for each level. */
+#define SET_PTL1_FLAGS_ARCH(ptl0, i, x) \
+	set_pt_level0_flags((pte_t *) (ptl0), (size_t) (i), (x))
+#define SET_PTL2_FLAGS_ARCH(ptl1, i, x)
+#define SET_PTL3_FLAGS_ARCH(ptl2, i, x)
+#define SET_FRAME_FLAGS_ARCH(ptl3, i, x) \
+	set_pt_level1_flags((pte_t *) (ptl3), (size_t) (i), (x))
+
+/* Macros for querying the last-level PTE entries. */
+#define PTE_VALID_ARCH(pte) \
+	(*((uint32_t *) (pte)) != 0)
+#define PTE_PRESENT_ARCH(pte) \
+	(((pte_t *) (pte))->l0.descriptor_type != 0)
+#define PTE_GET_FRAME_ARCH(pte) \
+	(((pte_t *) (pte))->l1.frame_base_addr << FRAME_WIDTH)
+#define PTE_WRITABLE_ARCH(pte) \
+	(((pte_t *) (pte))->l1.access_permission_0 == PTE_AP_USER_RW_KERNEL_RW)
+#define PTE_EXECUTABLE_ARCH(pte) \
+	1
+
+#ifndef __ASM__
+
+/** Level 0 page table entry. */
+typedef struct {
+	/* 0b01 for coarse tables, see below for details */
+	unsigned descriptor_type : 2;
+	unsigned impl_specific : 3;
+	unsigned domain : 4;
+	unsigned should_be_zero : 1;
+
+	/* Pointer to the coarse 2nd level page table (holding entries for small
+	 * (4KB) or large (64KB) pages. ARM also supports fine 2nd level page
+	 * tables that may hold even tiny pages (1KB) but they are bigger (4KB
+	 * per table in comparison with 1KB per the coarse table)
+	 */
+	unsigned coarse_table_addr : 22;
+} ATTRIBUTE_PACKED pte_level0_t;
+
+/** Level 1 page table entry (small (4KB) pages used). */
+typedef struct {
+
+	/* 0b10 for small pages */
+	unsigned descriptor_type : 2;
+	unsigned bufferable : 1;
+	unsigned cacheable : 1;
+
+	/* access permissions for each of 4 subparts of a page
+	 * (for each 1KB when small pages used */
+	unsigned access_permission_0 : 2;
+	unsigned access_permission_1 : 2;
+	unsigned access_permission_2 : 2;
+	unsigned access_permission_3 : 2;
+	unsigned frame_base_addr : 20;
+} ATTRIBUTE_PACKED pte_level1_t;
+
+typedef union {
+	pte_level0_t l0;
+	pte_level1_t l1;
+} pte_t;
+
+/* Level 1 page tables access permissions */
+
+/** User mode: no access, privileged mode: no access. */
+#define PTE_AP_USER_NO_KERNEL_NO	0
+
+/** User mode: no access, privileged mode: read/write. */
+#define PTE_AP_USER_NO_KERNEL_RW	1
+
+/** User mode: read only, privileged mode: read/write. */
+#define PTE_AP_USER_RO_KERNEL_RW	2
+
+/** User mode: read/write, privileged mode: read/write. */
+#define PTE_AP_USER_RW_KERNEL_RW	3
+
+
+/* pte_level0_t and pte_level1_t descriptor_type flags */
+
+/** pte_level0_t and pte_level1_t "not present" flag (used in descriptor_type). */
+#define PTE_DESCRIPTOR_NOT_PRESENT	0
+
+/** pte_level0_t coarse page table flag (used in descriptor_type). */
+#define PTE_DESCRIPTOR_COARSE_TABLE	1
+
+/** pte_level1_t small page table flag (used in descriptor type). */
+#define PTE_DESCRIPTOR_SMALL_PAGE	2
+
+
+/** Sets the address of level 0 page table.
+ *
+ * @param pt Pointer to the page table to set.
+ *
+ */
+NO_TRACE static inline void set_ptl0_addr(pte_t *pt)
+{
+	asm volatile (
+		"mcr p15, 0, %[pt], c2, c0, 0\n"
+		:: [pt] "r" (pt)
+	);
+}
+
+
+/** Returns level 0 page table entry flags.
+ *
+ * @param pt Level 0 page table.
+ * @param i  Index of the entry to return.
+ *
+ */
+NO_TRACE static inline int get_pt_level0_flags(pte_t *pt, size_t i)
+{
+	pte_level0_t *p = &pt[i].l0;
+	int np = (p->descriptor_type == PTE_DESCRIPTOR_NOT_PRESENT);
+	
+	return (np << PAGE_PRESENT_SHIFT) | (1 << PAGE_USER_SHIFT) |
+	    (1 << PAGE_READ_SHIFT) | (1 << PAGE_WRITE_SHIFT) |
+	    (1 << PAGE_EXEC_SHIFT) | (1 << PAGE_CACHEABLE_SHIFT);
+}
+
+/** Returns level 1 page table entry flags.
+ *
+ * @param pt Level 1 page table.
+ * @param i  Index of the entry to return.
+ *
+ */
+NO_TRACE static inline int get_pt_level1_flags(pte_t *pt, size_t i)
+{
+	pte_level1_t *p = &pt[i].l1;
+	
+	int dt = p->descriptor_type;
+	int ap = p->access_permission_0;
+	
+	return ((dt == PTE_DESCRIPTOR_NOT_PRESENT) << PAGE_PRESENT_SHIFT) |
+	    ((ap == PTE_AP_USER_RO_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_RW_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_RW_KERNEL_RW) << PAGE_WRITE_SHIFT) |
+	    ((ap != PTE_AP_USER_NO_KERNEL_RW) << PAGE_USER_SHIFT) |
+	    ((ap == PTE_AP_USER_NO_KERNEL_RW) << PAGE_READ_SHIFT) |
+	    ((ap == PTE_AP_USER_NO_KERNEL_RW) << PAGE_WRITE_SHIFT) |
+	    (1 << PAGE_EXEC_SHIFT) |
+	    (p->bufferable << PAGE_CACHEABLE);
+}
+
+/** Sets flags of level 0 page table entry.
+ *
+ * @param pt    level 0 page table
+ * @param i     index of the entry to be changed
+ * @param flags new flags
+ *
+ */
+NO_TRACE static inline void set_pt_level0_flags(pte_t *pt, size_t i, int flags)
+{
+	pte_level0_t *p = &pt[i].l0;
+	
+	if (flags & PAGE_NOT_PRESENT) {
+		p->descriptor_type = PTE_DESCRIPTOR_NOT_PRESENT;
+		/*
+		 * Ensures that the entry will be recognized as valid when
+		 * PTE_VALID_ARCH applied.
+		 */
+		p->should_be_zero = 1;
+	} else {
+		p->descriptor_type = PTE_DESCRIPTOR_COARSE_TABLE;
+		p->should_be_zero = 0;
+	}
+}
+
+
+/** Sets flags of level 1 page table entry.
+ *
+ * We use same access rights for the whole page. When page
+ * is not preset we store 1 in acess_rigts_3 so that at least
+ * one bit is 1 (to mark correct page entry, see #PAGE_VALID_ARCH).
+ *
+ * @param pt    Level 1 page table.
+ * @param i     Index of the entry to be changed.
+ * @param flags New flags.
+ *
+ */
+NO_TRACE static inline void set_pt_level1_flags(pte_t *pt, size_t i, int flags)
+{
+	pte_level1_t *p = &pt[i].l1;
+	
+	if (flags & PAGE_NOT_PRESENT) {
+		p->descriptor_type = PTE_DESCRIPTOR_NOT_PRESENT;
+		p->access_permission_3 = 1;
+	} else {
+		p->descriptor_type = PTE_DESCRIPTOR_SMALL_PAGE;
+		p->access_permission_3 = p->access_permission_0;
+	}
+	
+	p->cacheable = p->bufferable = (flags & PAGE_CACHEABLE) != 0;
+	
+	/* default access permission */
+	p->access_permission_0 = p->access_permission_1 = 
+	    p->access_permission_2 = p->access_permission_3 =
+	    PTE_AP_USER_NO_KERNEL_RW;
+	
+	if (flags & PAGE_USER)  {
+		if (flags & PAGE_READ) {
+			p->access_permission_0 = p->access_permission_1 = 
+			    p->access_permission_2 = p->access_permission_3 = 
+			    PTE_AP_USER_RO_KERNEL_RW;
+		}
+		if (flags & PAGE_WRITE) {
+			p->access_permission_0 = p->access_permission_1 = 
+			    p->access_permission_2 = p->access_permission_3 = 
+			    PTE_AP_USER_RW_KERNEL_RW; 
+		}
+	}
+}
+
+
+extern void page_arch_init(void);
+
+
+#endif /* __ASM__ */
+
 #endif
 
-#if defined(PROCESSOR_armv7)
-#include "page_armv7.h"
-#elif defined(PROCESSOR_armv4) | defined(PROCESSOR_armv5)
-#include "page_armv4.h"
-#endif
-
-#endif
-
 /** @}
  */
Index: kernel/arch/arm32/include/regutils.h
===================================================================
--- kernel/arch/arm32/include/regutils.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/include/regutils.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -41,20 +41,5 @@
 #define STATUS_REG_MODE_MASK         0x1f
 
-#define CP15_R1_MMU_ENABLE_BIT       (1 << 0)
-#define CP15_R1_ALIGNMENT_ENABLE_BIT (1 << 1)
-#define CP15_R1_CACHE_ENABLE_BIT     (1 << 2)
-#define CP15_R1_BRANCH_PREDICT_BIT   (1 << 11)
-#define CP15_R1_INST_CACHE_BIT       (1 << 12)
 #define CP15_R1_HIGH_VECTORS_BIT     (1 << 13)
-#define CP15_R1_ROUND_ROBIN_BIT      (1 << 14)
-#define CP15_R1_HA_ENABLE_BIT        (1 << 17)
-#define CP15_R1_WXN_BIT              (1 << 19) /* Only if virt. supported */
-#define CP15_R1_UWXN_BIT             (1 << 20) /* Only if virt. supported */
-#define CP15_R1_FI_BIT               (1 << 21)
-#define CP15_R1_VE_BIT               (1 << 24)
-#define CP15_R1_EE_BIT               (1 << 25)
-#define CP15_R1_NMFI_BIT             (1 << 27)
-#define CP15_R1_TRE_BIT              (1 << 28)
-#define CP15_R1_AFE_BIT              (1 << 29)
 
 /* ARM Processor Operation Modes */
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/src/arm32.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -49,5 +49,4 @@
 #include <str.h>
 #include <arch/ras.h>
-#include <sysinfo/sysinfo.h>
 
 /** Performs arm32-specific initialization before main_bsp() is called. */
@@ -117,8 +116,4 @@
 {
 	machine_input_init();
-	const char *platform = machine_get_platform_name();
-
-	sysinfo_set_item_data("platform", NULL, (void *) platform,
-	    str_size(platform));
 }
 
Index: kernel/arch/arm32/src/cpu/cpu.c
===================================================================
--- kernel/arch/arm32/src/cpu/cpu.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/src/cpu/cpu.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -44,17 +44,14 @@
 /** Implementators (vendor) names */
 static const char *imp_data[] = {
-	"?",                                     /* IMP_DATA_START_OFFSET */
-	"ARM Limited",                           /* 0x41 */
-	"", "",                                  /* 0x42 - 0x43 */
-	"Digital Equipment Corporation",         /* 0x44 */
-	"", "", "", "", "", "", "", "",          /* 0x45 - 0x4c */
-	"Motorola, Freescale Semicondutor Inc.", /* 0x4d */
-	"", "", "",                              /* 0x4e - 0x50 */
-	"Qualcomm Inc.",                         /* 0x51 */
-	"", "", "", "",                          /* 0x52 - 0x55 */
-	"Marvell Semiconductor",                 /* 0x56 */
-	"", "", "", "", "", "", "", "", "", "",  /* 0x57 - 0x60 */
-	"", "", "", "", "", "", "", "",          /* 0x61 - 0x68 */
-	"Intel Corporation"                      /* 0x69 */
+	"?",					/* IMP_DATA_START_OFFSET */
+	"ARM Ltd",				/* 0x41 */
+	"",					/* 0x42 */
+	"",                             	/* 0x43 */
+	"Digital Equipment Corporation",	/* 0x44 */
+	"", "", "", "", "", "", "", "", "", "",	/* 0x45 - 0x4e */
+	"", "", "", "", "", "", "", "", "", "", /* 0x4f - 0x58 */
+	"", "", "", "", "", "", "", "", "", "", /* 0x59 - 0x62 */
+	"", "", "", "", "", "",			/* 0x63 - 0x68 */
+	"Intel Corporation"			/* 0x69 */
 };
 
@@ -100,23 +97,4 @@
 void cpu_arch_init(void)
 {
-#if defined(PROCESSOR_armv7)
-	uint32_t control_reg = 0;
-	asm volatile (
-		"mrc p15, 0, %[control_reg], c1, c0"
-		: [control_reg] "=r" (control_reg)
-	);
-	
-	/* Turn off tex remap */
-	control_reg &= ~CP15_R1_TRE_BIT;
-	/* Turn off accessed flag */
-	control_reg &= ~(CP15_R1_AFE_BIT | CP15_R1_HA_ENABLE_BIT);
-	/* Enable caching */
-	control_reg |= CP15_R1_CACHE_ENABLE_BIT;
-	
-	asm volatile (
-		"mcr p15, 0, %[control_reg], c1, c0"
-		:: [control_reg] "r" (control_reg)
-	);
-#endif
 }
 
@@ -134,12 +112,11 @@
 	cpu_arch_t * cpu_arch = &m->arch;
 
-	const unsigned imp_offset = cpu_arch->imp_num - IMP_DATA_START_OFFSET;
-
-	if (imp_offset < imp_data_length) {
+	if ((cpu_arch->imp_num) > 0 &&
+	    (cpu_arch->imp_num < (imp_data_length + IMP_DATA_START_OFFSET))) {
 		vendor = imp_data[cpu_arch->imp_num - IMP_DATA_START_OFFSET];
 	}
 
-	// TODO CPUs with arch_num == 0xf use CPUID scheme for identification
-	if (cpu_arch->arch_num < arch_data_length) {
+	if ((cpu_arch->arch_num) > 0 &&
+	    (cpu_arch->arch_num < arch_data_length)) {
 		architecture = arch_data[cpu_arch->arch_num];
 	}
Index: kernel/arch/arm32/src/exception.c
===================================================================
--- kernel/arch/arm32/src/exception.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/src/exception.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -120,32 +120,18 @@
 static void high_vectors(void)
 {
-	uint32_t control_reg = 0;
+	uint32_t control_reg;
 	
-#if defined(PROCESSOR_armv7)
-	asm volatile (
-		"mrc p15, 0, %[control_reg], c1, c0"
-		: [control_reg] "=r" (control_reg)
-	);
-#elif defined(PROCESSOR_armv4) | defined(PROCESSOR_armv5)
 	asm volatile (
 		"mrc p15, 0, %[control_reg], c1, c1"
 		: [control_reg] "=r" (control_reg)
 	);
-#endif
 	
 	/* switch on the high vectors bit */
 	control_reg |= CP15_R1_HIGH_VECTORS_BIT;
 	
-#if defined(PROCESSOR_armv7)
-	asm volatile (
-		"mcr p15, 0, %[control_reg], c1, c0"
-		:: [control_reg] "r" (control_reg)
-	);
-#elif defined(PROCESSOR_armv4) | defined(PROCESSOR_armv5)
 	asm volatile (
 		"mcr p15, 0, %[control_reg], c1, c1"
 		:: [control_reg] "r" (control_reg)
 	);
-#endif
 }
 #endif
Index: kernel/arch/arm32/src/machine_func.c
===================================================================
--- kernel/arch/arm32/src/machine_func.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/src/machine_func.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -42,5 +42,4 @@
 #include <arch/mach/integratorcp/integratorcp.h>
 #include <arch/mach/testarm/testarm.h>
-#include <arch/mach/beagleboardxm/beagleboardxm.h>
 
 /** Pointer to machine_ops structure being used. */
@@ -56,6 +55,4 @@
 #elif defined(MACHINE_integratorcp)
 	machine_ops = &icp_machine_ops;
-#elif defined(MACHINE_beagleboardxm)
-	machine_ops = &bbxm_machine_ops;
 #else
 #error Machine type not defined.
@@ -134,10 +131,4 @@
 }
 
-const char * machine_get_platform_name(void)
-{
-	if (machine_ops->machine_get_platform_name)
-		return machine_ops->machine_get_platform_name();
-	return NULL;
-}
 /** @}
  */
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/arch/arm32/src/mm/page.c	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -52,16 +52,14 @@
 void page_arch_init(void)
 {
-	int flags = PAGE_CACHEABLE | PAGE_EXEC;
+	int flags = PAGE_CACHEABLE;
 	page_mapping_operations = &pt_mapping_operations;
 
 	page_table_lock(AS_KERNEL, true);
 	
+	uintptr_t cur;
+
 	/* Kernel identity mapping */
-	//FIXME: We need to consider the possibility that
-	//identity_base > identity_size and physmem_end.
-	//This might lead to overflow if identity_size is too big.
-	for (uintptr_t cur = PHYSMEM_START_ADDR;
-	    cur < min(KA2PA(config.identity_base) +
-	        config.identity_size, config.physmem_end);
+	for (cur = PHYSMEM_START_ADDR;
+	    cur < min(config.identity_size, config.physmem_end);
 	    cur += FRAME_SIZE)
 		page_mapping_insert(AS_KERNEL, PA2KA(cur), cur, flags);
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ kernel/genarch/Makefile.inc	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -101,9 +101,4 @@
 endif
 
-ifeq ($(CONFIG_AMDM37X_UART),y)
-	GENARCH_SOURCES += \
-		genarch/src/drivers/amdm37x_uart/amdm37x_uart.c
-endif
-
 ifeq ($(CONFIG_VIA_CUDA),y)
 	GENARCH_SOURCES += \
Index: tools/mkuimage.py
===================================================================
--- tools/mkuimage.py	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ tools/mkuimage.py	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -120,5 +120,5 @@
 	header.start_addr = start_addr	# Address of entry point
 	header.data_crc = data_crc
-	header.os = 2			# NetBSD
+	header.os = 5			# Linux
 	header.arch = 2			# ARM
 	header.img_type = 2		# Kernel
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ uspace/Makefile	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -174,9 +174,4 @@
 endif
 
-ifeq ($(UARCH),arm32)
-	DIRS += \
-		drv/infrastructure/rootamdm37x
-endif
-
 ## System libraries
 #
Index: uspace/drv/bus/usb/ehci/ehci.ma
===================================================================
--- uspace/drv/bus/usb/ehci/ehci.ma	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ uspace/drv/bus/usb/ehci/ehci.ma	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -1,2 +1,1 @@
-20 usb/host=ehci
 10 pci/class=0c&subclass=03&progif=20
Index: uspace/drv/bus/usb/ohci/ohci.ma
===================================================================
--- uspace/drv/bus/usb/ohci/ohci.ma	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ uspace/drv/bus/usb/ohci/ohci.ma	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -1,2 +1,1 @@
-20 usb/host=ohci
 10 pci/class=0c&subclass=03&progif=10
Index: uspace/drv/bus/usb/ohci/ohci_regs.h
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_regs.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ uspace/drv/bus/usb/ohci/ohci_regs.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -228,5 +228,5 @@
 #define RHPS_PRSC_FLAG (1 << 20) /* port reset status change WC */
 #define RHPS_CHANGE_WC_MASK 0x1f0000
-} ohci_regs_t;
+} __attribute__((packed)) ohci_regs_t;
 #endif
 /**
Index: uspace/lib/usbdev/include/usb/dev/request.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/request.h	(revision c127e1ccb10c2c7b86a2fce5e27f2378ecb9a6a9)
+++ uspace/lib/usbdev/include/usb/dev/request.h	(revision d11a1811118ec8e5eb8ca4beae291275a4ce36b6)
@@ -93,8 +93,8 @@
 	uint8_t request;
 	/** Main parameter to the request. */
-	union __attribute__ ((packed)) {
+	union {
 		uint16_t value;
 		/* FIXME: add #ifdefs according to host endianness */
-		struct __attribute__ ((packed)) {
+		struct {
 			uint8_t value_low;
 			uint8_t value_high;
@@ -108,6 +108,4 @@
 	uint16_t length;
 } __attribute__ ((packed)) usb_device_request_setup_packet_t;
-
-int assert[(sizeof(usb_device_request_setup_packet_t) == 8) ? 1: -1];
 
 int usb_control_request_set(usb_pipe_t *,
